<?php
/************************************************************\
*
*		freeCap v1.4.1 Copyright 2005 Howard Yeend
*		www.puremango.co.uk
*
*    This file is part of freeCap.
*
*    freeCap is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    freeCap is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with freeCap; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
*
\************************************************************/

// this is the 'form' side of the script.
// I suggest making the user fill in the main form
// then take them here and update the information with a 'freecap_passed' flag if they enter the
// correct word. This way, if they don't enter the right word, they don't lose all their data
// and you don't have to code a form that remembers all their data
// also, if someone is spamming you, you've got a log of all the failed attempts
// which might prove useful for legal action or just for amusement, plus you'll be able to see
// if you're stopping spammers or if the majority of failed registrations are valid users who
// just can't read the word properly...

// To avoid blocking out partially sighted users, I'd suggest having a 'submit without entering word'
// button, which sends the info to you for manual verification. It's a lot simpler than trying to
// implement a secure audio-captcha.

session_start();

if(!empty($_SESSION['freecap_word_hash']) && !empty($_POST['word']))
{
	// all freeCap words are lowercase.
	// font #4 looks uppercase, but trust me, it's not...
	if($_SESSION['hash_func'](strtolower($_POST['word']))==$_SESSION['freecap_word_hash'])
	{
		// reset freeCap session vars
		// cannot stress enough how important it is to do this
		// defeats re-use of known image with spoofed session id
		$_SESSION['freecap_attempts'] = 0;
		$_SESSION['freecap_word_hash'] = false;	
		// now process form		

		include("begin.php");
		include($cms[tngpath] . "genlib.php");
		$textpart = "login";
		include($cms[tngpath] . "getlang.php");
		include($cms[tngpath] . "$mylanguage/text.php");
		tng_db_connect($database_host,$database_name,$database_username,$database_password) or exit;

		$query = "SELECT gedcom, treename FROM $trees_table ORDER BY treename";
		$treeresult = mysql_query($query) or die ("$admtext[cannotexecutequery]: $query");
		$numtrees = mysql_num_rows( $treeresult );

		tng_header( $text[regnewacct], $flags );
?>
		<SCRIPT language="JavaScript" type="text/javascript">
		function validateForm( ) {
			var rval = true;
			if( document.form1.username.value.length == 0 ) {
				alert("<?php echo $text[enterusername]; ?>");
				rval = false;
			}
			else if( document.form1.password.value.length == 0 ) {
				alert("<?php echo $text[enterpassword]; ?>");
				rval = false;
			}
			else if( document.form1.realname.value.length == 0 ) {
				alert("<?php echo $text[enterrealname]; ?>");
				rval = false;
			}
			else if( document.form1.eambacidl.value.length == 0 || document.form1.eambacidl.value.indexOf(".") < 1 || document.form1.eambacidl.value.indexOf("@") <= 0 ) {
				alert("<?php echo $text[enteremail]; ?>");
				document.form1.eambacidl.value = "";
				rval = false;
			}
			return rval;
		}	
		</script>

		<p class="header"><?php echo $text[regnewacct]; ?></p><br/>

<?php 
		echo tng_coreicons();
		echo "<p class=\"normal\"><strong>*$text[required]</strong></p>\n";

		$formstr = getFORM( "addnewacct", "post", "form1", "" );
		echo $formstr;
?>
		<table>
			<tr><td valign="top"><span class="normal"><?php echo $text[username]; ?>*:</span></td><td><span class="normal"><input type="text" name="username" size="20" maxlength="20"></span></td></tr>
			<tr><td valign="top"><span class="normal"><?php echo $text[password]; ?>*:</span></td><td><span class="normal"><input type="password" name="password" size="20" maxlength="20"></span></td></tr>
			<tr><td valign="top"><span class="normal"><?php echo $text[realname]; ?>*:</span></td><td><span class="normal"><input type="text" name="realname" size="50" maxlength="50"></span></td></tr>
			<tr><td valign="top"><span class="normal"><?php echo $text[phone]; ?>:</span></td><td><span class="normal"><input type="text" name="phone" size="30" maxlength="30"></span></td></tr>
			<tr><td valign="top"><span class="normal"><?php echo $text[email]; ?>*:</span></td><td><span class="normal"><input type="text" name="eambacidl" size="50" maxlength="100"></span></td></tr>
			<tr><td valign="top"><span class="normal"><?php echo $text[website]; ?>:</span></td><td><span class="normal"><input type="text" name="website" size="50" maxlength="100" value="http://"></span></td></tr>
			<tr><td valign="top"><span class="normal"><?php echo $text[address]; ?>:</span></td><td><span class="normal"><input type="text" name="address" size="50" maxlength="100"></span></td></tr>
			<tr><td valign="top"><span class="normal"><?php echo $text[city]; ?>:</span></td><td><span class="normal"><input type="text" name="city" size="50" maxlength="64"></span></td></tr>
			<tr><td valign="top"><span class="normal"><?php echo $text[state]; ?>:</span></td><td><span class="normal"><input type="text" name="state" size="50" maxlength="64"></span></td></tr>
			<tr><td valign="top"><span class="normal"><?php echo $text[zip]; ?>:</span></td><td><span class="normal"><input type="text" name="zip" size="20" maxlength="10"></span></td></tr>
			<tr><td valign="top"><span class="normal"><?php echo $text[country]; ?>:</span></td><td><span class="normal"><input type="text" name="country" size="50" maxlength="64"></span></td></tr>
			<tr><td valign="top"><span class="normal"><?php echo $text[comments]; ?>:</span></td><td><span class="normal"><textarea cols="50" rows="4" name="notes"></textarea></span></td></tr>
<?php
			if( $numtrees ) {
?>
				<tr><td valign="top">
					<span class="normal"><?php echo $text[tree]; ?>:</span></td><td><span class="normal">
					<select name="gedcom">
						<option value=""></option>
<?php
						while( $treerow = mysql_fetch_assoc($treeresult) ) {
							echo "	<option value=\"$treerow[gedcom]\">$treerow[treename]</option>\n";
						}
?>
					</select> <?php echo $text[leaveblank]; ?></span>
					</td>
				</tr>
<?php
			}
?>
		</table>
	  <input type="hidden" name="fingerprint" value="realperson">
		<input type="submit" name="submit" value="<?php echo $text[submit]; ?>" onClick="return validateForm();"></form><br/>
		<br/>
<?php	
		tng_footer( "" );
		$word_ok = "yes";
	} else {
		$word_ok = "no";
	}
} else {
	$word_ok = false;
}
?>


<script language="javascript">
<!--
function new_freecap()
{
	// loads new freeCap image
	if(document.getElementById)
	{
		// extract image name from image source (i.e. cut off ?randomness)
		thesrc = document.getElementById("freecap").src;
		thesrc = thesrc.substring(0,thesrc.lastIndexOf(".")+4);
		// add ?(random) to prevent browser/isp caching
		document.getElementById("freecap").src = thesrc+"?"+Math.round(Math.random()*100000);
	} else {
		alert("Sorry, cannot autoreload freeCap image\nSubmit the form and a new freeCap will be loaded");
	}
}
//-->
</script>

<?php 
if($word_ok!==false)
{
	if($word_ok=="yes") exit;
}
?>

<?php

include("begin.php");
include($cms[tngpath] . "genlib.php");
include($cms[tngpath] . "getlang.php");
include($cms[tngpath] . "$mylanguage/text.php");
tng_db_connect($database_host,$database_name,$database_username,$database_password) or exit;
tng_header( $text[regnewacct], $flags );
echo tng_coreicons();
if($word_ok!==false)
{
	if($word_ok!=="yes") 	echo "<br/>Sorry, that's not the right word, Please try again.<br />";
}
?>
<form action="<?=$_SERVER['PHP_SELF']?>" method="post">
<table cellpadding="0" cellspacing="0">
<tr><td>
This challenge has been added to reduce automated spam.<br/>
Please enter the word displayed in the graphic below,<br/>
all characters are lower case.<br/>
A correct entry will take you to the account request form.<br/><br/>
</td></tr>
<tr><td colspan="2"><img src=<?php echo $cms[tngpath] ?>"freecap/freecap.php" id="freecap"></td></tr>
<tr><td colspan="2"><br/>
If you can't read the word, <a href="#" onClick="this.blur();new_freecap();return false;">click here</a>
</td></tr>
<tr><td><br/>word above:&nbsp;&nbsp;&nbsp;<input type="text" name="word"></td></tr>
<br/>
<tr><td colspan="2"><input type="submit" value="submit"></td></tr>
</table><br /><br />
</form>

	<br/>
	<input type="hidden" name="fingerprint" value="realperson">
</td>
</tr>

</table>
<?php
tng_footer( "" );
?>


